#CONTROLCODES 1
#INCLUDE "/BASIC/INCLUDES/STANDARD.DEF"
FIFOFULL = %10000000
BIT16.ON = %00100000
STEREO.ON = %00010000
VOLMASK = %11110000
VOLMAX = %11111111
DefaultVolume = 14
MaxVolume = 15

PRINT "{ISO ON}
COLOR 1,0
CLS
PRINT
AUDIOTRACK$="BA.16000.2.ZCM"
PRINT "{LIGHT GREEN} F1 {YEL}-{WHT} English"
TARGET = TI+120
FOR I = 0 TO -1 STEP 0
    GET X$
    X=ASC(X$)
    IF X = 133 THEN AUDIOTRACK$="BA.16000.ENG.ZCM":TARGET=TI-1:ENGLISH = -1
    I = (TI>TARGET)
NEXT
CLS
X=0
IF NOT ENGLISH THEN SkipLanguageMsg
 PRINT
 PRINT "{LIGHT GREEN}English Sound Track Selected {RED}!{WHT}":PRINT

SkipLanguageMsg:
PRINT
PRINT " TESTING FILE SYSTEM"
PRINT
PRINT "{GRN}    F1 -{WHT} Green Screen"
PRINT
PRINT "{ORG}    F2 -{WHT} Amber Screen"
PRINT
PRINT "{YEL}    F3 -{WHT} Crazy Random"
PRINT "{RED}"
PRINT RPT$(178,80);
GOSUB TestFileSystem
SLEEP 60
BLOAD "APPLEPLAYER.BIN",8,3,$A000
IF IsHostFS THEN SKIPFAST
  DOS "U0>B3"
  FASTMODE = -1
SKIPFAST:
BADAPPLE = $A02D
LOAD.HOST.LOADER:
  PRINT"{RED}":PRINT MSG$;:SLEEP 90
  GOSUB LOADFRAMECODE
  PRINT "{WHT}":PRINT
  TARGET = 0
  FRAME.RATE = 15
  FRAME.INC = 60/FRAME.RATE

GOSUB SETMONO320X240
COLOR 1,0
CLS
GOSUB CLEAR.GRAPHICSBUFFER
OPEN 4,8,4,"BADAPPLE.15FPS.A,S,R"
REM F$="BA.WAV"
DefaultVolume = 14
REM GOSUB LOADWAVE


F$=AUDIOTRACK$
GOSUB GetZCMHeader

GOTO PLAY.BadApple

PLAY.BadApple:
   FillLoopCount = 6
   IF IsHostFS THEN FillLoopCount = 12
   POKE A.REG, FillLoopCount
   POKE X.REG, 6
   POKE R0L, VERA.RATE
   POKE R0H, VERA.CFG
   GOSUB SOFTSCREEN
   GET X$
   X=ASC(X$)
   IF X=133 THEN GOSUB GREENSCREEN
   IF X=137 THEN GOSUB AMBERSCREEN
   IF X=134 THEN GOSUB RANDOMCOLORS
   BANK 3
   SYS BADAPPLE
   SCREEN 0
   PRINT "DONE":PRINT
   GOSUB DEFAULTSCREEN
   END

LOADWAVE:
   GOSUB LoadWAVEHeader
   GOSUB ParseRIFFHeader
   RETURN

GetZCMHeader:
  IsWave = FALSE
  OPEN 6,8,6,F$+",S,R"
  FOR I = 1 TO 6:GET# 6, X$:NEXT I
  GET# 6, X$
  VERA.CFG = ASC(X$)
  GET# 6, X$
  VERA.RATE = ASC(X$)
  BytesPerSecond = ((VERA.RATE/128) * 48828.15)
  PCMBits = 8
  IF (VERA.CFG AND BIT16.ON) = BIT16.ON THEN PCMBits=16:BytesPerSecond = BytesPerSecond*2
  IsStereo = ((VERA.CFG AND STEREO.ON) = STEREO.ON)
  VERA.CFG = ((VERA.CFG AND %11110000) OR DefaultVolume)
  IF IsStereo THEN BytesPerSecond = BytesPerSecond * 2
  BytesPerSecond = FN ROUND(BytesPerSecond)
  RETURN

ParseRIFFHeader:
  IsWave = (LEFT$(RIFFHDR$,4) = "RIFF") AND (MID$(RIFFHDR$,9,4)="WAVE")
  PCMBits = ASC(MID$(RIFFHDR$,35,1))
  TMP1 = ASC(MID$(RIFFHDR$,21,1))
  TMP2 = ASC(MID$(RIFFHDR$,22,1))
  NumChannels = ASC(MID$(RIFFHDR$,23,1))
  TMP4 = (TMP1) + (256*TMP2)
  IsPCM = (TMP4=1)
  TMP1 = ASC(MID$(RIFFHDR$,25,1))
  TMP2 = ASC(MID$(RIFFHDR$,26,1)) * 256
  TMP3 = ASC(MID$(RIFFHDR$,27,1)) * 65536
  SampleRate = TMP1+TMP2+TMP3
  VERA.RATE = FN ROUND((SampleRate / 48828.15) * 128)
  IsStereo = (NumChannels=2)
  IsSupported = (IsWave AND (PCMBits=16)) AND IsPCM AND ((NumChannels > 0) AND (NumChannels < 3))
  VERA.CFG=0
  IF NOT IsSupported THEN RETURN
  VERA.CFG = (VERA.CFG OR BIT16.ON)
  IF IsStereo THEN VERA.CFG = (VERA.CFG OR STEREO.ON)
  VERA.CFG = VERA.CFG OR DefaultVolume
  BytesPerSecond = ((VERA.RATE/128) * 48828.15)*2
  IF IsStereo THEN BytesPerSecond = BytesPerSecond*2
  BytesPerSecond = FN ROUND(BytesPerSecond)
  RETURN

LoadWAVEHeader:
   RIFFHDR$ = RPT$(44,44)
   OPEN 6,8,6,F$+",S,R"
     POKE X.REG, 6
     SYS CHKIN
     POKE A.REG, 44
## GET A POINTER TO THE WAVEHDR STRING THEN PEEK
## IT FOR THE ADDRESS TO THE STRING DATA
     A=POINTER(RIFFHDR$)+1
     POKE X.REG, PEEK(A)
     POKE Y.REG, PEEK(A+1)
     POKE C.REG, 0
     SYS MACPTR
     SYS CLRCHN
     RETURN

TestFileSystem:
 F$="TESTFILE":GOSUB FILEEXISTS
 IF FE% THEN StartTest
 OPEN 2,8,2,"@:TESTFILE,S,W"
 FOR I = 1 TO 100
     PRINT# 2, "ABCDEFGHIJKLMN"
 NEXT I
 CLOSE 2
StartTest:
 OPEN 2,8,2,"TESTFILE,S,R"
 POKE X.REG,2
 SYS CHKIN
 BANK 63
 POKE X.REG,$00
 POKE Y.REG,$A0
 POKE C.REG, 0
 POKE A.REG, 0
 SYS MACPTR
 IsHostFS = (PEEK(Y.REG) = 1)
 SYS CLRCHN
 CLOSE 2
 RETURN






ANIMFILES:
 DATA "BADAPPLE.15FPS.A","Bad Apple !",3285

SETMONO320X240:
  SCREEN $80
  RECT 0,0,XLIMIT,YLIMIT,0
  POKE VERA.L0.CONFIG, BITMAP.MONO
  RETURN

DEFAULTSCREEN:
 GB=0:R=0:GOSUB SETBACKGROUND
 GB=$FF:R=$F:GOTO SETFOREGROUND

SOFTSCREEN:
 P1=$1D:P2=1:GOSUB COPYPALET
 P1=$12:P2=0:GOTO COPYPALET

AMBERSCREEN:
 GB=$11:R=$1:GOSUB SETBACKGROUND
 P1=$50:P2=1:GOTO COPYPALET

GREENSCREEN:
 GB=$11
 R=1:GOSUB SETBACKGROUND
 GB=$B0
 R=0:GOTO SETFOREGROUND

RANDOMCOLORS:
 C1=INT(RND(.)*256)
TRYAGAIN:
 C2=INT(RND(.)*256)
 IF C2=C1 THEN TRYAGAIN
 P1=C1:P2=0:GOSUB COPYPALET
 P1=C2:P2=1:GOTO COPYPALET

SETBACKGROUND:
  VPOKE 1,$FA00,GB
  VPOKE 1,$FA01,R
  RETURN

SETFOREGROUND:
  VPOKE 1,$FA02, GB
  VPOKE 1,$FA03, R
  RETURN

RGBPAL:
  A=P1*2:X=(G%*16)+B%:A=A+$FA00:SLEEP:VPOKE 1,A,X:A=A+1:SLEEP:VPOKE 1,A,R%:RETURN

COPYPALET:
  VPOKE 1,$FA00+(P2*2),VPEEK(1,$FA00+(P1*2)):VPOKE 1,$FA00+(P2*2)+1,VPEEK(1,$FA00+(P1*2)+1):RETURN

#INCLUDE "/BASIC/INCLUDES/STANDARD.BI"

LOADFRAMECODE:
 RESTORE FRAME.LOADER.CODE
 FOR A=$700 TO $76B
     READ C
     POKE A, C
     PRINT ".";
 NEXT A
 PRINT
 RETURN

FRAME.LOADER.CODE:
DATA 230,5,162,4,32,198,255,169,37,133,2,203,165,32,240,17,169,20,141,47,159,169,0,133,32,141,32,159,141,33,159,128,17,169,1,133,32,169,0,141,47,159,141,32,159,169,40,141,33,159,169,16,141
DATA 34,159,162,35,160,159,169,255,56,32,68,255,198,2,208,242,162,35,160,159,169,165,56,32,68,255,32,204,255,230,30,240,2,128,4,230,31,128,0,32,228,255,201,27,240,8,198,4,208,155,198,5,208
DATA 151,96

RUN
